'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _postcss = require('postcss');

var _postcss2 = _interopRequireDefault(_postcss);

exports['default'] = _postcss2['default'].plugin('postcss-center', function () {
    return function (root) {
        root.eachRule(function (rule) {
            var top = undefined;
            rule.eachDecl('top', function (decl) {
                if (decl.value !== 'center') {
                    return;
                }
                top = decl;
                decl.value = '50%';
            });
            var left = undefined;
            rule.eachDecl('left', function (decl) {
                if (decl.value !== 'center') {
                    return;
                }
                left = decl;
                decl.value = '50%';
            });
            if (!top && !left) {
                return;
            }
            var position = undefined;
            rule.eachDecl('position', function (decl) {
                if (/^(absolute|relative|fixed)$/.test(decl.value)) {
                    position = decl.value;
                    return;
                }
                decl.removeSelf();
            });
            if (!position) {
                (top || left).cloneBefore({
                    prop: 'position',
                    value: 'absolute'
                });
            }
            var translate = undefined;
            if (top && left) {
                translate = '(-50%, -50%)';
            } else if (top) {
                translate = 'Y(-50%)';
            } else {
                translate = 'X(-50%)';
            }
            (left || top).cloneAfter({
                prop: 'transform',
                value: 'translate' + translate
            });
            if (left && position !== 'relative') {
                left.cloneAfter({
                    prop: 'margin-right',
                    value: '-50%'
                });
            }
        });
    };
});
module.exports = exports['default'];